.filenamespace waves
*=$1000

mainStartup:
	ldx #%10111010
	stx $d40f
	stx $d413
	stx $d414

mainloop:
	lda $d41b
	and #1     // random on and off sound
	ora #128   // noise
	sta $d412

	ldx #15    // leave at least 5
	stx 54296

!loop:
	// x is 25 after first loop, but it is ok for overwrite start addresses
	lda startdata-1,x
	sta $1f-1,x
	dex
	bne !loop-

lineloop:
	txa
	asl
	asl
	cmp $d41b  // move line by random generator
	bcc !next+
	inc $40,x
!next:
	lda $40,x
	tax
	ldy #39

!loop:
	lda #$0f
	.byte $cb, $ff // SBX #$FF
	lda wavedata-1,x
	sta ($1f),y
	lda colordata-1,x
	sta ($21),y
	dey
	bpl !loop-

	lda $1f
	adc #40
	sta $1f
	sta $21
	bcc !next+
	inc $20
	inc $22
!next:

	jsr $B5FF // increment hidden x counter
	cpx #25
	bne lineloop
	beq mainloop	

wavedata:
	.byte 111, 70, 67, 69, 119, 119, 119, 69, 68, 67, 70, 82, 82, 111, 111, 111
	// alternative wave shape
//	.byte 111, 111, 100, 77, 119, 119, 119, 69, 68, 67, 70, 82, 82, 111, 111, 111

colordata:
	.byte 3, 7, 1, 1, 1, 7, 3, 12, 12, 14, 14, 14, 11, 11, 11, 12

startdata:
	.word $0400, $d800
	.byte $00 // x counter



